<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SEG_Tarea.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Mantenimiento de los registros de la tabla SEG_Tarea */
abstract class BaseSEG_TareaDP extends SEG_TareaBV
{
    /* Constructor ( Establece los valores desde un objeto SEG_TareaBN ) */
    public function __construct( SEG_TareaBN $o_SEG_TareaBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SEG_TareaBN ) )
        {
            $this->setByBN( $o_SEG_TareaBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SEG_TareaBN */
    public function setByBN( SEG_TareaBN $o_SEG_TareaBN )
    {
        if ( !is_null( $o_SEG_TareaBN->getIdTarea() ) )
        {
            $this->setIdTarea( $o_SEG_TareaBN->getIdTarea() );
        }
        if ( !is_null( $o_SEG_TareaBN->getTareaDescripcion() ) )
        {
            $this->setTareaDescripcion( $o_SEG_TareaBN->getTareaDescripcion() );
        }
        if ( !is_null( $o_SEG_TareaBN->getBotonTexto() ) )
        {
            $this->setBotonTexto( $o_SEG_TareaBN->getBotonTexto() );
        }
        if ( !is_null( $o_SEG_TareaBN->getTareaTipo() ) )
        {
            $this->setTareaTipo( $o_SEG_TareaBN->getTareaTipo() );
        }
        if ( !is_null( $o_SEG_TareaBN->getScriptId() ) )
        {
            $this->setScriptId( $o_SEG_TareaBN->getScriptId() );
        }
        if ( !is_null( $o_SEG_TareaBN->getDeshabilitadoFlg() ) )
        {
            $this->setDeshabilitadoFlg( $o_SEG_TareaBN->getDeshabilitadoFlg() );
        }
        if ( !is_null( $o_SEG_TareaBN->getIdPatron() ) )
        {
            $this->setIdPatron( $o_SEG_TareaBN->getIdPatron() );
        }
        if ( !is_null( $o_SEG_TareaBN->getIdSubSistema() ) )
        {
            $this->setIdSubSistema( $o_SEG_TareaBN->getIdSubSistema() );
        }
        if ( !is_null( $o_SEG_TareaBN->getInicialPassthru() ) )
        {
            $this->setInicialPassthru( $o_SEG_TareaBN->getInicialPassthru() );
        }
        if ( !is_null( $o_SEG_TareaBN->getSeleccionFixed() ) )
        {
            $this->setSeleccionFixed( $o_SEG_TareaBN->getSeleccionFixed() );
        }
        if ( !is_null( $o_SEG_TareaBN->getSeleccionTemp() ) )
        {
            $this->setSeleccionTemp( $o_SEG_TareaBN->getSeleccionTemp() );
        }
        if ( !is_null( $o_SEG_TareaBN->getSettings() ) )
        {
            $this->setSettings( $o_SEG_TareaBN->getSettings() );
        }
        if ( !is_null( $o_SEG_TareaBN->getOrdenarPor() ) )
        {
            $this->setOrdenarPor( $o_SEG_TareaBN->getOrdenarPor() );
        }
        if ( !is_null( $o_SEG_TareaBN->getMantenerDatos() ) )
        {
            $this->setMantenerDatos( $o_SEG_TareaBN->getMantenerDatos() );
        }
        if ( !is_null( $o_SEG_TareaBN->getLogSqlQuery() ) )
        {
            $this->setLogSqlQuery( $o_SEG_TareaBN->getLogSqlQuery() );
        }
        if ( !is_null( $o_SEG_TareaBN->getScreenRefresh() ) )
        {
            $this->setScreenRefresh( $o_SEG_TareaBN->getScreenRefresh() );
        }
        if ( !is_null( $o_SEG_TareaBN->getUsaHttps() ) )
        {
            $this->setUsaHttps( $o_SEG_TareaBN->getUsaHttps() );
        }
        if ( !is_null( $o_SEG_TareaBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SEG_TareaBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SEG_TareaBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SEG_TareaBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SEG_TareaBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SEG_TareaBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SEG_TareaBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SEG_TareaBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SEG_TareaFN = new SEG_TareaFN();
        $o_SEG_TareaBN = $o_SEG_TareaFN->selectByPk( $this->getIdTarea() );
        if ( is_null( $o_SEG_TareaBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SEG_Tarea ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdTarea() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTarea";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTarea()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTareaDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TareaDescripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTareaDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getBotonTexto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."BotonTexto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getBotonTexto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTareaTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TareaTipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTareaTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getScriptId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ScriptId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getScriptId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDeshabilitadoFlg() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DeshabilitadoFlg";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDeshabilitadoFlg()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPatron() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPatron";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdPatron()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSubSistema() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSubSistema";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdSubSistema()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicialPassthru() ) )
            {
                $s_SQLQuery1 .= $s_Separator."InicialPassthru";
                $s_SQLQuery2 .= $s_Separator."'".$this->getInicialPassthru()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSeleccionFixed() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SeleccionFixed";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSeleccionFixed()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSeleccionTemp() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SeleccionTemp";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSeleccionTemp()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSettings() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Settings";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSettings()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenarPor() ) )
            {
                $s_SQLQuery1 .= $s_Separator."OrdenarPor";
                $s_SQLQuery2 .= $s_Separator."'".$this->getOrdenarPor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMantenerDatos() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MantenerDatos";
                $s_SQLQuery2 .= $s_Separator."'".$this->getMantenerDatos()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getLogSqlQuery() ) )
            {
                $s_SQLQuery1 .= $s_Separator."LogSqlQuery";
                $s_SQLQuery2 .= $s_Separator."'".$this->getLogSqlQuery()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getScreenRefresh() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ScreenRefresh";
                $s_SQLQuery2 .= $s_Separator."".$this->getScreenRefresh()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsaHttps() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsaHttps";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsaHttps()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SEG_Tarea SET ";
            $s_Separator = "";
            if ( !is_null( $this->getTareaDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."TareaDescripcion = '".$this->getTareaDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getBotonTexto() ) )
            {
                $s_SQLQuery .= $s_Separator."BotonTexto = '".$this->getBotonTexto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTareaTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."TareaTipo = '".$this->getTareaTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getScriptId() ) )
            {
                $s_SQLQuery .= $s_Separator."ScriptId = '".$this->getScriptId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDeshabilitadoFlg() ) )
            {
                $s_SQLQuery .= $s_Separator."DeshabilitadoFlg = '".$this->getDeshabilitadoFlg()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPatron() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPatron = '".$this->getIdPatron()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSubSistema() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSubSistema = '".$this->getIdSubSistema()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicialPassthru() ) )
            {
                $s_SQLQuery .= $s_Separator."InicialPassthru = '".$this->getInicialPassthru()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSeleccionFixed() ) )
            {
                $s_SQLQuery .= $s_Separator."SeleccionFixed = '".$this->getSeleccionFixed()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSeleccionTemp() ) )
            {
                $s_SQLQuery .= $s_Separator."SeleccionTemp = '".$this->getSeleccionTemp()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSettings() ) )
            {
                $s_SQLQuery .= $s_Separator."Settings = '".$this->getSettings()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOrdenarPor() ) )
            {
                $s_SQLQuery .= $s_Separator."OrdenarPor = '".$this->getOrdenarPor()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMantenerDatos() ) )
            {
                $s_SQLQuery .= $s_Separator."MantenerDatos = '".$this->getMantenerDatos()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getLogSqlQuery() ) )
            {
                $s_SQLQuery .= $s_Separator."LogSqlQuery = '".$this->getLogSqlQuery()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getScreenRefresh() ) )
            {
                $s_SQLQuery .= $s_Separator."ScreenRefresh = ".$this->getScreenRefresh()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsaHttps() ) )
            {
                $s_SQLQuery .= $s_Separator."UsaHttps = '".$this->getUsaHttps()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdTarea = '".$this->getIdTarea()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SEG_Tarea WHERE  IdTarea = '".$this->getIdTarea()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>